#include "mbed.h"
#include "MSCFileSystem.h"

//Declare interrupt pin 
//InterruptIn killSwitch(p21);

//USB Setup 
DigitalOut USBSelect(p24);
MSCFileSystem fs("fs");

//Stopwatch timer
Timer speedTime;
Timer motorTime; 
Timer loopTime;

//Battery Level Input
AnalogIn battery(p20);

//Indicator Lights
DigitalOut led1(LED1);
DigitalOut led2(LED2);
DigitalOut led3(LED3); 

CANMessage msg;

//Analog Mux
AnalogIn analogIn(p15);
//AnalogOut analogOut (p18);

DigitalOut enA (p10);
BusOut selectAnalog (p11,p12,p13,p14);

//Digital Mux
AnalogIn digitalIn (p16);
//DigitalOut digitalOut (p17);

DigitalOut enD (p5);
BusOut selectDigital (p6,p7,p8,p9);

//CAN communication
CAN can1 (p30,p29);
DigitalOut canEn (p26);

//Variables
int count;
int gearH, gearL, gearR;
char gearPos;
int fuel1, fuel2, fuel3, fuel4, fuel5, fuelLev;
int speed1, speed1a, speed2, speed3, speed4, rpm;
double x1, y1, z1, x2, y2, z2;
double temp, clutch,vBatt;
int vBattery; 
double susp1, susp2, susp3, susp4;
int speedB, teethB, dataCollectTime;
int motor, rpm1, teethMotor;
double timeMotor, motorRPM, rpmMotor;
double timeB, circumfB, backSpeed, frontSpeed;
int i,j,k;
char filename[64];
int variable=0;
double timeLoop;
int timeCAN = 0; 
int TIME_CAN_MAX = 1000;

/*
//Interrupt Routine
void trigger() {
     printf("Interrupt Routine triggered \n\r"); 
     //FILE *fp = fopen(filename, "a+"); //open file and add to it    
   //store data onto USB
     x2 = 10;
     y2 = 10;
     z2 = 10;
     fprintf(fp,"%s,%d,%d, %d,%d,%d,%d,%d,%d,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f \n",NULL, gearR,gearL,gearH,fuel1,fuel2,fuel3,fuel4,fuel5,backSpeed,frontSpeed,motorRPM,x1,y1,z1,x2,y2,z2,temp,clutch,vBatt);
     fclose(fp);
   //send CAN message possibly to say shutting down
     led2=!led2; //indicator LED turns on when finished writing to USB 
     wait(1); //wait for power to turn off
}
*/

void Polling(){
                    enA = 1; 
                    enD = 1; 
                
                     //Speed 1 - back wheel
                    count = 10;
                    speedB = 0;
                    circumfB = 0.58; //in meters
                    teethB = 20;    
                    selectDigital = 12;
                    wait_us(0.05);
                    
                    speedTime.start();
                    while (count > 0){
                        speed1 = digitalIn.read();
                   //     digitalOut = speed1;
                        if (speed1 < 1 & speed1a == !speed1){
                            speedB = speedB + 1;
                        }
                        speed1a = speed1; 
                        count = count - 1; 
                    }
                    timeB = speedTime.read_ms(); //may change to nano seconds
                    timeB = timeB/1000; //convert mili sec to sec
                    backSpeed = speedB/timeB * circumfB / teethB; //speed in m/sec
                    backSpeed = backSpeed * 3.6; //speed in km/hr
                    speedTime.reset();  
                   
               //    printf("Back speed: %f\n", backSpeed);
                    /*       
                    //Speed 2 - front wheel 
                    count = 1;         
                    selectDigital = 13;
                    wait_us(0.05);
                    
                    while (count > 0){
                        speed2 = digitalIn.read();
                        digitalOut = speed2;
                        count = count - 1; 
                    }*/
                
                    //Reverse Gear
                   // count = 1;         
                    selectDigital = 0;
                    wait_us(0.05);
                    
                  //  while (count > 0){
                        gearR = digitalIn.read();
                    //    digitalOut = gearR;
                    //    count = count - 1; 
                    //}
                    
                //   printf("Reverse Gear: %d\n", gearR);
                    
                    //Low Gear
                   // count = 1;         
                    selectDigital = 1;
                    wait_us(0.05);
                    
                   // while (count > 0){
                        gearL = digitalIn.read();
                    //    digitalOut = gearL;
                      //  count = count - 1; 
                  //  }
                  
             //     printf("Low Gear: %d\n", gearL);
                    
                    //High Gear
                   // count = 1;         
                    selectDigital = 2;
                    wait_us(0.05);
                    
                  //  while (count > 0){
                        gearH = digitalIn.read();
                    //    digitalOut = gearH;
                    //    count = count - 1; 
                   // }
              //     printf("High Gear: %d\n", gearH);
                           
                    //Fuel 5
                  //  count = 1;         
                    selectDigital = 3;
                    wait_us(0.05);
                    
                   // while (count > 0){
                        fuel5 = digitalIn.read();
                    //    digitalOut = fuel5;
                    //    count = count - 1; 
                   // }   
                   
                //   printf("Fuel five (empty): %d\n", fuel5);     
                           
                    //Fuel 4
                   // count = 1;         
                    selectDigital = 4;
                    wait_us(0.05);
                    
                  //  while (count > 0){
                        fuel4 = digitalIn.read();
                    //    digitalOut = fuel4;
                     //   count = count - 1; 
                   // } 
               //   printf("Fuel four: %d\n", fuel4);     
            
                                 
                    //Fuel 3
                    //count = 1;         
                    selectDigital = 5;
                    wait_us(0.05);
                    
                    
                  //  while (count > 0){
                        fuel3 = digitalIn.read();
                   //     digitalOut = fuel3;
                   //     count = count - 1; 
                   // }
                    
                //    printf("Fuel three: %d\n", fuel3);     
            
            
                           
                    //Fuel 2
                   // count = 1;         
                    selectDigital = 6;
                    wait_us(0.05);
                    
                   // while (count > 0){
                        fuel2 = digitalIn.read();
                   //     digitalOut = fuel2;
                   //     count = count - 1; 
                   // }
               //    printf("Fuel two: %d\n", fuel2);     
            
                           
                    //Fuel 1
                    //count = 1;         
                    selectDigital = 7;
                    wait_us(0.05);
                    
                   // while (count > 0){
                        fuel1 = digitalIn.read();
                   //     digitalOut = fuel1;
                   //     count = count - 1; 
                   // }
               //    printf("Fuel one (full): %d\n", fuel1);     
            
                           
                    //Motor rpm
                    count = 10; 
                    motor = 0;
                    teethMotor = 12;     //check this number   
                    selectDigital = 11;
                    rpm1 = 1;
                        
                    wait_us(0.05);
                    
                    motorTime.start();
                    while (count > 0){
                        rpm = digitalIn.read();
            
                        //digitalOut = rpm;
                       if (rpm < 1 & rpm1 == !rpm){
                            motor = motor + 1;
                        }
                        rpm1 = rpm; 
                        count = count - 1; 
                    }
                     
                    timeMotor = motorTime.read_ms(); //may change to nano seconds
                //    printf("Time Motor (ms): %f\n", timeMotor);
                    timeMotor = timeMotor/1000; //change time to seconds
                //    printf("Time Motor (sec): %f\n", timeMotor);
                    motor = motor/timeMotor; //teeth per second
               //    printf("motor: %d\n", motor);
                    motorRPM = motor*60/teethMotor; //revolutions per minute
               //     printf("RPM: %f\n", motorRPM);
                    motorTime.reset();  
                    rpmMotor = motorRPM/1000; //should be a value between 0-40 thousand rpm
                    
                 //   printf("Send to CAN: %f\n", rpmMotor);
                    
                    //Clutch
                   // count = 1;         
                    selectAnalog = 15;
                    wait_us(0.05);
             
                  // while (count > 0){
                       clutch = analogIn.read(); 
                   //    analogOut = clutch;            
                     //  count = count - 1;  
                  // }
                    
                 //   printf("Clutch: %f\n", clutch);
                    //Accelerometer x1
                    //count = 1;         
                    selectAnalog = 0;
                    wait_us(0.05);
             
                   //while (count > 0){
                       x1 = analogIn.read(); 
                       //analogOut = x1;            
                       //count = count - 1;  
                   //}
                   
                //   printf("X: %f\n", x1);
                   
                   //Accelerometer y1
                    //count = 1;         
                    selectAnalog = 1;
                    wait_us(0.05);
             
                   //while (count > 0){
                       y1 = analogIn.read(); 
                      // analogOut = y1;            
                     //  count = count - 1;  
                  // }
                  
               //   printf("Y: %f\n", y1);
                    
                   //Accelerometer z1
                   // count = 1;         
                    selectAnalog = 2;
                    wait_us(0.05);
             
                  // while (count > 0){
                       z1 = analogIn.read(); 
                     //  analogOut = z1;            
                     //  count = count - 1;  
                   //}
                //   printf("Z: %f\n", z1);
            
                   //Temperature (sig4)
                    //count = 1;         
                    selectAnalog = 8;
                    wait_us(0.05);
             
                   //while (count > 0){
                       temp = analogIn.read(); 
                     //  analogOut = temp;            
                     //  count = count - 1;  
                   //}
                   /*
                   //Suspension 1 
                    count = 1;         
                    enA = 1; 
                    selectAnalog = 11;
                    enA = 0;    
                    wait_us(0.05);
             
                   while (count > 0){
                       susp1 = analogIn.read(); 
                       analogOut = susp1;            
                       count = count - 1;  
                   }
                   
                   //Suspension 2
                    count = 1;         
                    enA = 1; 
                    selectAnalog = 12;
                    enA = 0;    
                    wait_us(0.05);
             
                   while (count > 0){
                       susp2 = analogIn.read(); 
                       analogOut = susp2;            
                       count = count - 1;  
                   }
                   
                   //Suspension 3
                    count = 1;         
                    enA = 1; 
                    selectAnalog = 13;
                    enA = 0;    
                    wait_us(0.05);
             
                   while (count > 0){
                       susp3 = analogIn.read(); 
                       analogOut = susp3;            
                       count = count - 1;  
                   }
                   
                   //Suspension 4
                    count = 1;         
                    enA = 1; 
                    selectAnalog = 14;
                    enA = 0;    
                    wait_us(0.05);
             
                   while (count > 0){
                       susp4 = analogIn.read(); 
                       analogOut = susp4;            
                       count = count - 1;  
                   }*/
                   
            //Battery Level
                   vBatt = battery.read();
}

//Main Program

int main() { 

    loopTime.start();
    
    USBSelect = 0; //enable USB channel 1
    
    canEn = 0; //enable CAN
    can1.frequency(250000); 
     
    //Set Time and Date
        
       //*****DO THIS THE FIRST TIME ONLY!********
        //set_time(1328382900); //seconds since Jan. 1, 1970 - use Unix Time Converter http://www.epochconverter.com/  
        //started on Feb. 4, 2012 at 19:15:00 
        
      
        char date[32];
        char time1[32];
        char time2[32];
        char time3[32];
       
    
    while(1){   //while forever

//Create File 
        time_t seconds = time(NULL);
        strftime(time1, 32, "%H_%M_%S", localtime(&seconds));
        strftime(date, 32, "%m/%d/%y", localtime(&seconds));
        sprintf(filename, "/fs/%s.csv", time1);
        FILE *fp = fopen(filename, "w"); 
        wait(0.5);
        fprintf(fp,"Date(MM/DD/YY): %s \n", date); 
        strftime(time2, 32, "%H:%M:%S", localtime(&seconds));
        fprintf(fp,"Start Time: %s \n", time2);
        wait(0.5); 
        fprintf(fp,"Time, gearR,gearL,gearH,fuel1,fuel2,fuel3,fuel4,fuel5,backSpeed(km/h),Frontspeed(km/h),RPM,x1,y1,z1,x2,y2,z2,temp(C),clutch(cm),battery(V) \n");
        wait(0.5); 
//printf("\n\r New file created %s \n\r", time1);         

//Go to Interrupt Routine    
   //   killSwitch.rise(&trigger);
     
         i = 10;  //save j dataspoints to USB before closing file
         
         while(i>0){ //print to USB 
                  
            //Request Data from Display
                while(!can1.read(msg) && (timeCAN < TIME_CAN_MAX) ){
                    timeCAN++;//wait until data is received
                }
                 
                if(timeCAN < TIME_CAN_MAX){
                    variable = msg.data[0];//if data is received store (x2, y2, z2, frontSpeed)
                    printf("CAN message received: %d, %d, %d, %d id:%d\r\n", variable, msg.data[1],msg.data[2],msg.data[3],msg.id);
                }else{
                    printf("CAN message timeout\r\n");
                    x2 = NULL;//if no data timeout and store as null
                    y2 = NULL;
                    z2 = NULL;
                    frontSpeed = NULL;
                }
                 
                timeCAN = 0;
                
                j = 10;
                while(j>0){ //Polling routine and send to display      
//Polling Routine       
//printf("Enter Polling Routine \n\r");                    
             Polling();    
             
            //Send data to Display
                    //convert to gear
                    gearPos = 0; // N 
                    if (gearL==0){
                        gearPos = 1;
                    }
                    if (gearH==0){
                        gearPos = 2;
                    }
                    if (gearR==0){
                        gearPos = 3; 
                    }
                
                    //convert to fuel level 1-4 (1=Empty 5=Full)
                    fuelLev = 5; //Full 
                    
                    if (fuel1==1){
                        fuelLev = 4; 
                    }
                    if (fuel2==1){
                        fuelLev = 3; 
                    }
                    if (fuel3==1){
                        fuelLev = 2; 
                    }
                    if (fuel4==1){
                        fuelLev = 1; 
                    }
                    if (fuel5==1){
                        fuelLev = 0; //Empty 
                    }
                    
                    //Remove after testing!!!    
                    
                    vBatt = 0.83; 
                    vBattery = vBatt * 100; //80-100
                    rpmMotor = 35; //0-40
                    backSpeed = 65; //0-150
                    temp = 10; //0-180
                    
                    //cast to char
                    char batLev = (char) vBattery; 
                    char gearPosition = (char) gearPos;
                    char fuelLevel = (char) fuelLev;
                    char rpm_motor = (char) rpmMotor;
                    char temperature = (char) temp; 
                    char wheelSpeed = (char) backSpeed; 
                    
                    char dataCAN[8] = {rpm_motor,fuelLevel,gearPosition,batLev,temperature, wheelSpeed,0,0};
                    
//send data to display (gearPos, fuelLev, backSpeed, rpmMotor, batLev, temp)
                    if (can1.write(CANMessage(0xFF01FF, dataCAN, 8, CANData, CANExtended))){
                       // printf("Sending CAN message \n\r");
                    }else{
                       // printf("Display not connected \n\r"); 
                    } 
                    timeLoop = loopTime.read(); 
                    j--; 
                    wait(0.1);
                }//close j while loop
                
//Print to USB 
            time_t seconds = time(NULL);
            strftime(time3, 32, "%H:%M:%S", localtime(&seconds));
            fprintf(fp,"%s,%d,%d, %d,%d,%d,%d,%d,%d,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f \n",time3, gearR,gearL,gearH,fuel1,fuel2,fuel3,fuel4,fuel5,backSpeed,frontSpeed,motorRPM,x1,y1,z1,x2,y2,z2,temp,clutch,vBatt);
            timeLoop = loopTime.read(); 
            i--; 
//printf("Printing to USB \n\r");   
            led1 = !led1;          
        }//close i while loop
              
        wait(0.5); 
        fclose(fp);
        //printf("close file \n\r");
        wait(2); //Polling CAN during wait **** 
        timeLoop = loopTime.read(); 
        loopTime.reset(); 
        led2 = !led2;         
//printf("Closing File \n\r");        
    }//close forever while loop        
}//close main